import React, { Component } from 'react';
import {Text} from './index.js';
import { Label, FormGroup, Input, NavbarText, Modal, ModalBody } from 'reactstrap';
 
class Captcha extends Component {
 
  constructor(props) {
    super(props)
  }

  componentDidMount() {
    // this will generate captcha and insert it in captcha div
    this.props.captchaImageText();
  }
 
  render() {
    const {optionsObj, defaultLng, defaultValue, reqData, onChange, errorMsg, onError, assignResponseValue, onSubmit} = this.props;
    return (
        <div className="row">
          <div className="col-md-8 col-sm-8 col-lg-8">
			<Text optionsObj={optionsObj !== undefined ? optionsObj : {}} defaultLng={defaultLng} defaultValue={defaultValue} reqData={reqData} onChange={onChange} errorMsg={errorMsg} onError={onError} assignResponseValue={assignResponseValue} onSubmit={onSubmit} />
		  </div>	
		  <div id="captcha" className="col-md-4 captch_class"></div>
        </div>
    );
  }
}
 
export default Captcha;