/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control text
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { Label, FormGroup, Input, Button, Row } from 'reactstrap';
//  import AppConfig from 'DefaultConstants/AppConfig';
//  import { injectIntl } from 'react-intl';
 /**
  * Start Datepicker class component
  * @state {*Object} reqData
  */
 class CustomDatePicker extends Component {
     constructor(props) {
         super(props);
         this.state = {
             selectedDay: "",
             days: [
                 { value: 1, label: 1 },
                 { value: 2, label: 2 },
                 { value: 3, label: 3 },
                 { value: 4, label: 4 },
                 { value: 5, label: 5 },
                 { value: 6, label: 6 },
                 { value: 7, label: 7 },
                 { value: 8, label: 8 },
                 { value: 9, label: 9 },
                 { value: 10, label: 10 },
                 { value: 11, label: 11 },
                 { value: 12, label: 12 },
                 { value: 13, label: 13 },
                 { value: 14, label: 14 },
                 { value: 15, label: 15 },
                 { value: 16, label: 16 },
                 { value: 17, label: 17 },
                 { value: 18, label: 18 },
                 { value: 19, label: 19 },
                 { value: 20, label: 20 },
                 { value: 21, label: 21 },
                 { value: 22, label: 22 },
                 { value: 23, label: 23 },
                 { value: 24, label: 24 },
                 { value: 25, label: 25 },
                 { value: 26, label: 26 },
                 { value: 27, label: 27 },
                 { value: 28, label: 28 },
                 { value: 29, label: 29 },
                 { value: 30, label: 30 },
                 { value: 31, label: 31 },
             ],
         }
     }
     /* handle time select */
     onSelectDay = (value) => {
         this.setState({ selectedDay: value });
     }
     render() {
         const { intl } = this.props;
         const { days, selectedDay } = this.state;
         return (
             <div className="calender_area">
                 {/* days */}
                 <div className="day_area cal_box">
                     {days.map((day, index) => {
                         return <Button onClick={() => this.onSelectDay(day.value)} color="secondary" className={`btn_cal ${day.value === selectedDay && 'active'}`}>{day.value}</Button>
                     })}
                     <Button color="secondary" onClick={() => this.onSelectDay(-1)} className={`btn_cal btn_last_month ${-1 === selectedDay && 'active'}`}>{intl.formatMessage({ id: "occurrence.lastDayOfTheMonth" })}</Button>
                 </div>
             </div>
         )
     }
 }
 export default CustomDatePicker