/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file type1
 *
 * Initial all package and component required for this component
 * injectIntl : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import { post } from 'axios';
 import { Label, FormGroup, Input, Button } from 'reactstrap';
 // import IntlMessages from "Util/IntlMessages";
//  const { FileDetails, ModelDialog } = require('DefaultComponents/Widgets')
//  import WebCamera, { FACING_MODES, IMAGE_TYPES } from 'react-html5-camera-photo';
//  import 'react-html5-camera-photo/build/css/index.css';
//  const { swaggerPostAPI, swaggerGetAPI, redirectToLogin, getFileSizeToBase64String, getValueUsingKey, callNativeFunction, checkReactNativeWebView, convertBase64ToFile, getNotificationFunction, convertToCompressFile } = require('DefaultHelpers');
//  import AppConfig from 'DefaultConstants/AppConfig';
 import $ from 'jquery';
 import dot from 'dot-object';
 const Compress = require('compress.js')
 dot.override = true;
 
 /**
  * Start File Type1 class component
  * @state {*Object} reqData
  */
 class FileUploadMobile extends Component {
     constructor(props) {
         super(props);
         this.state = {
             fileData: {},
             loader: false,
             name: props.optionsObj.name
         }
 
         this.setValue = this.setValue.bind(this);
         // if (props.optionsObj.name !== undefined && props.optionsObj.name !== '' && checkReactNativeWebView()) {
         // alert("run call")
         window.fileUploadMobile = this;
         let self = this;
         const { props: { optionsObj: { name: inputName = '' } = {} } = {} } = self;
         setTimeout(function () {
             $("#divForAddScript").append(`<script type="text/javascript">function onDataReceiveFromRN${inputName}(child_id, data){ window.fileUploadMobile.setValue(child_id, data,"${self.props.optionsObj.name}");}</script>`)
         }, 500);
         // }
 
     }
 
     setValue(child_id, data, fileFieldName) {
         if (child_id === "onTakePhoto" || child_id === "onTakeVideo") {
 
             try {
                 const { optionsObj: { isShowFileDetails = false } = {} ,convertBase64ToFile} = this.props;
                 let resData = data.replace(/__@@__/g, '"');//(data);
                 resData = JSON.parse(/* JSON.stringify */(resData))
                 let { ext = "", filePath = "", inputName = "", name: fileName = "", size = 0, sizeLabel = 0, type = "", value = "", imageUrl = '', fileExtension = '',
                     validType, validSize, validateImage = {} } = resData;
                 // alert("run onFileUpload" + '|' + inputName + '|' + ext + '|' + fileName + '|' + type)
                 value = value !== '' ? value : imageUrl;
                 inputName = inputName !== '' ? inputName : fileFieldName;
                 let fileData = [{
                     imageUrl: value,
                     name: fileName,
                     size: size,
                     sizeLabel: sizeLabel,
                     type: type,
                     fileExtension: ext !== '' ? ext : fileExtension
                 }]
 
                 // if (isShowFileDetails) {
                 //     this.setState({ fileData: { [inputName]: fileData[0] } }/* , () => {
                 //         alert(JSON.stringify(this.state.fileData))
                 //     } */);
                 // }
                 // console.log('fileData :', fileData, resData)
                 // this.props.onChange(this.props.optionsObj.type !== undefined ? this.props.optionsObj.type : 'text', inputName, data)
                 // this.props.onChange('file', inputName, fileData, '', fileData, '', '', 1)
                 const { optionsObj: { onChangeURL = '', kycPath = '', kycResponseBindFrom = '' } = {}, assignResponseValue, reqData, savedObject } = this.props;
                 // alert("start val validSize|" + validSize + ":" + size)
                 let startProcess = this.checkFileValidation(fileData[0], inputName, validType, validSize);
                 // alert("start val|" + startProcess)
                 if (startProcess && typeof convertBase64ToFile === 'function' ) {
                     // alert("start assign")
                     assignResponseValue(inputName, 'loading');
                     // alert("run here 13|start convert")
                     let returnObject = convertBase64ToFile(value, inputName);
                     let formData = returnObject.formData;
                     // let formData = new FormData();
                     // alert("run here 13|" + kycPath)
                     if (kycPath !== '') {
                         let kycPathNew = kycPath;
                         // alert(kycResponseBindFrom)
                         // alert(JSON.stringify(savedObject))
                         if (kycResponseBindFrom !== '') {
                             kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);//getValueUsingKey(responseBindFrom, savedObject)
                         }
                         // alert(kycPathNew)
                         formData.append('keyType', kycPathNew);
                     } else {
                         formData.append('kycField', inputName);
                     }
                     // console.log('returnObject :', fileData)
                     formData.append(kycPath !== '' ? 'files' : 'file', returnObject.blob, fileData[0].name);
                     // formData.append('files', webCameraObj, webCameraObj.name);
                     let targetFile = {
                         files: [{
                             name: fileName,
                             size: size,
                             sizeLabel: sizeLabel,
                             type: type,
                             fileExtension: ext,
                             imageUrl: value
                         }]
                     }
                     this.uploadFile(formData, targetFile, inputName, fileData, validateImage);
                 }
 
             } catch (e) {
                 alert("run onFileUpload E " + e.message)
                 if(typeof this.props.getNotificationFunction === 'function'){
                 this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
            }
 
         }
     }
 
     deleteFile = () => {
         const { optionsObj: { name = '' } = {}, assignResponseValue } = this.props;
         this.setState({ fileData: { [name]: {} }, isDelete: true }, () => assignResponseValue(name, '', '', true));
         /* if (typeof assignResponseValue === 'function') {
             assignResponseValue(name, '', '', true)
         } */
     }
 
     downloadFile = (inputName) => {
         const { callNativeFunction, checkReactNativeWebView } = this.props
         // const { optionsObj: { name: inputName = '' } = {} } = this.props;
         const { reqData: { [inputName]: { imageUrl = '', name = '' } = {} } = {} } = this.props;
         if (typeof checkReactNativeWebView === 'function') {
             if (checkReactNativeWebView() && typeof callNativeFunction === 'function') {
                 // alert("name|" + name +"|"+inputName)
                 callNativeFunction("onDownloadFile", { based64String: imageUrl, name });
             } else {
                 if (imageUrl !== '') {
                     const downloadLink = document.createElement("a");
                     downloadLink.href = imageUrl.trim();
                     downloadLink.download = name;
                     downloadLink.click();
                 }
             }
         }
     }
 
     /* compress event */
     convertToCompressFile = (e, compressObj = {}) => {
         const { size = 2, quality = 0.75, maxWidth = 1920, maxHeight = 1920, resize = true } = compressObj;
         const compress = new Compress();
         const files = [...e.target.files];
         const compressResponse = compress.compress(files, {
             size: size, // the max size in MB, defaults to 2MB
             quality: quality, // the quality of the image, max is 1,
             maxWidth: maxWidth, // the max width of the output image, defaults to 1920px
             maxHeight: maxHeight, // the max height of the output image, defaults to 1920px
             resize: resize, // defaults to true, set false if you do not want to resize the image width and height
         })
 
         return compressResponse;
     }
 
     checkFileValidation = (fileObject, inputFieldName, validType, size) => {
         try {
             let targetFile = fileObject;
             let fileType = targetFile.type;
             let fileSize = targetFile.size;
             let fileTypeExtension = '.' + targetFile.name.toString().split('.').pop();// targetFiles[0].type;
             // let validType = type !== '' ? type : [];
             let dynamicKeyValue = 'frm_file_' + (inputFieldName !== '' ? inputFieldName : 'textFileInput');
             let fieldId = inputFieldName !== '' ? inputFieldName : dynamicKeyValue + "id";
 
             if (fileType !== '' && Array.isArray(validType) && validType.length > 0 && !validType.includes(fileType)) {
                 $("#" + fieldId).val('');
                 // alert("fileType||" + fileType)
                 // this.props.onChange('file_type1', inputName, {})
                 this.props.onChange('file', inputFieldName, '', '', [fileObject], '', '', 1)
                 return false;
             } else if (fileType === '' && !validType.includes(fileTypeExtension)) {
                 $("#" + fieldId).val('');
                 // this.props.onChange('file_type1', inputName, {})
                 // alert("fileTypefileTypeExtension||")
                 this.props.onChange('file', inputFieldName, '', '', [fileObject], '', '', 1)
                 return false;
             } else if (size !== undefined && size !== '' && parseFloat(fileSize) > parseFloat(size)) {
                 $("#" + fieldId).val('');
                 this.props.onChange('file', inputFieldName, '', '', [fileObject], '', '', 1)
                 // alert("size||")
                 // this.props.onChange('file_type1', inputName, {})
                 return false;
             } else {
                 // alert("success||")
                 return true;
             }
 
         } catch (e) {
             alert("run file validation " + e.message)
             if(typeof this.props.getNotificationFunction === 'function'){
             this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
            }
             return false;
         }
     }
 
     // function for file upload into server and get id from response and set into request Object
     uploadFile = async (formData, targetFile, inputFieldName = '', fileObject, validateImage = {}) => {
        const { AppConfig: { nodeAPIUrl = {}, authorizationToken = {} } = {} , swaggerGetAPI, redirectToLogin} = this.props;
         // this.setState({ loader: true });
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name: inputName = '' } = {}, assignResponseValue } = this.props;
 
         let response = '';
         const loaderTime = 200;
         const url = nodeAPIUrl + onChangeURL;
         let authorizationToken1 = localStorage.getItem('front_authorize_token');
         const selfProcessStart = sessionStorage.getItem('selfProcessStart') !== undefined ? sessionStorage.getItem('selfProcessStart') : '';
         if (selfProcessStart !== '' && selfProcessStart == 1) {
             authorizationToken1 = sessionStorage.getItem('front_temp_authorize_token');
         }
         const config = {
             headers: {
                 'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                 'authorization': authorizationToken + authorizationToken1
                 // get token from local storage
             }
         }
 
         if (changeMethod !== '' && changeMethod === 'POST') {
             var self = this;
             // alert("call api")
             // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
             try {
                 post(url, formData, config).then((apiResponse) => {
                     const { data: response = {} } = apiResponse;
                     // alert("call api||" + JSON.stringify(apiResponse))
 
                     // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                     if (apiResponse !== undefined && apiResponse.status === 401 && typeof redirectToLogin === 'function' ) {
                         redirectToLogin();
                     } else if (response.responseCode === 0) {
                         let bindData = '';
                         if (changeResponseField !== '') {
                             bindData = dot.pick(changeResponseField, response);
                         } else {
                             bindData = dot.pick('data.fileUniqueId', response);
                         }
 
                         const { files: { [0]: { name = '' } = {} } = {} } = targetFile;
                         if (name !== '') {
                             let extension = name.toString().split('.').pop();
                             bindData = bindData + '.' + extension;
                         }
                         // alert("bindData|" + bindData + "|" + inputFieldName)
                         // this.setState({ fileData: bindData });
                         /* let { fileData } = self.state;
                         fileData[inputFieldName] = bindData;
                         self.setState({ fileData }); */
                         // alert("afdsf|" + JSON.stringify(validateImage) + "|" + inputFieldName)
                         self.checkImageValidation(validateImage, response, assignResponseValue, bindData, function (isSuccess) {
                             if (isSuccess) {
                                 // alert("asjdfhjsf|" + isSuccess)
                                 if (typeof assignResponseValue === 'function') {
                                     setTimeout(() => {
                                         if (changeBindIn !== '')
                                             assignResponseValue(changeBindIn, bindData, 'fileUniqueId'); // first argument field and second response value
                                         else
                                             assignResponseValue(inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', bindData, 'fileUniqueId');
                                     }, 1000)
                                 }
                                 self.props.onChange('file', inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', '', '', fileObject, '', '', bindData)
                             } else if (!isSuccess) {
                                 assignResponseValue(inputFieldName, '', '', true);
                             }
 
                             setTimeout(() => {
                                 self.setState({ loader: false });
                             }, loaderTime);
 
                         });
                     } else if (response.responseCode > 0) {
                         // this.setState({ fileData: {} });
                         /* let { fileData } = self.state;
                         fileData[inputFieldName] = bindData;
                         self.setState({ fileData }); */
                         self.props.onChange('file', inputFieldName, '')
                         if (changeBindIn === '')
                             self.props.onChange('', inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', '', '', '')
                         self.props.onError(inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', `error.message.${response.errCode !== undefined ? response.errCode : 9999}`)
                         // getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.{}` }));
 
                         setTimeout(() => {
                             self.setState({ loader: false });
                         }, loaderTime);
 
                     }
 
                 })
             } catch (e) {
 
                 setTimeout(() => {
                     self.setState({ loader: false });
                 }, loaderTime);
 
                 self.setState({ fileData: {} });
                 self.props.onChange('file', inputFieldName, '')
                 alert("run onFileUpload Eupload " + e.message)
                 // getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
             // to do handle response of post method
         } else if(typeof swaggerGetAPI === 'function'){
                 response = await swaggerGetAPI(onChangeURL, data, true);
                 // response = { responseCode: 0, data: { billAmount: 1000 } }
                 if (response.responseCode === 0) {
                     if (typeof assignResponseValue === 'function') {
                         assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                     }
                 } else if (response.responseCode === 1) {
                     this.setState({ fileData: {} });
                     this.props.onError(e.target.name, `error.message.${response.errCode}`)
                 }
             setTimeout(() => {
                 this.setState({ loader: false });
             }, loaderTime);
         }
     }
 
     componentWillUnmount() {
         this.setState({ fileData: {} })
     }
 
     deleteFile = () => {
         const { optionsObj: { name = '' } = {}, assignResponseValue } = this.props;
         assignResponseValue(name, '', '', true);
         /* if (typeof assignResponseValue === 'function') {
             assignResponseValue(name, '', '', true)
         } */
     }
 
     onClickEvent = (ComponentType) => {
         const {callNativeFunction} = this.props
         // alert("ComponentType|" + ComponentType)
         const { optionsObj: { size, type, validateImage = {} } = {} } = this.props;
         const { name: inputName = '' } = this.state;
         if (ComponentType == 10 && typeof callNativeFunction === 'function') {
             callNativeFunction("onTakePhoto", { size, type, inputName, validateImage })
         } else if (ComponentType == 12 && typeof callNativeFunction === 'function') {
             callNativeFunction("onTakeVideo", { size, type, inputName, validateImage });
         }
     }
 
     checkImageValidation = async (validateImage, response, assignResponseValue, fileId, callback) => {
        // const {getValueUsingKey} = this.props
         try {
        const { swaggerPostAPI ,swaggerGetAPI ,getValueUsingKey} = this.props;
            
             let { enabled = false, request = [], apiMethod = '', apiUrl = '', changeBindIn = '', changeResponseField = '' } = validateImage;
             if (enabled && apiUrl !== '') {
 
                 let { reqData = {}, savedObject = {} } = this.props;
                 let apiRequest = { data: {} };
                 Array.isArray(request) && request.map((item) => {
                     const { key = '', value = '', isFromResponse = false } = item;
                     if (key !== '' && key === 'fileUniqueId') {
                         apiRequest.data[key] = fileId;
                     } else if (key !== '' && key === 'userIdentifier') {
                         if (localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                             apiRequest.data[key] = localStorage.getItem('user');
                         else if (sessionStorage.getItem('user') !== null && sessionStorage.getItem('user') !== undefined)
                             apiRequest.data[key] = sessionStorage.getItem('user');
                     } else if (key !== '' && typeof getValueUsingKey === 'function' ) {
                         if (isFromResponse) {
                             apiRequest.data[key] = getValueUsingKey(value, response);
                         } else {
                             apiRequest.data[key] = getValueUsingKey(value, { ...savedObject, ...reqData });
                         }
                     } else {
                         apiRequest.data[key] = '';
                     }
                 });
 
                 let resData = {};
                 if (apiMethod !== '' && apiMethod.toString().toLowerCase() === 'post' && typeof swaggerPostAPI === 'function') {
                     resData = await swaggerPostAPI(apiUrl, apiRequest, true);
                 } else if(typeof this.props.swaggerGetAPI === 'function'){
                     if (apiUrl.toString().indexOf("?")) {
                         apiUrl = apiUrl + '&' + encodeQueryData(apiRequest.data);
                     } else {
                         apiUrl = apiUrl + '?' + encodeQueryData(apiRequest.data);
                     }
                     resData = await swaggerGetAPI(apiUrl, apiRequest, true);
                 }
 
                 const { responseCode = 1, errCode = '' } = resData;
                 if (responseCode === 0) {
                     if (changeBindIn !== '' && changeResponseField !== '' && typeof getValueUsingKey === 'function') {
                         setTimeout(() => {
                             assignResponseValue(changeBindIn, getValueUsingKey(changeResponseField, resData));
                         }, 1000);
                     }
                     callback(true);
                 } else if(typeof this.props.getNotificationFunction === 'function'){
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.${errCode}` }));
                     callback(false);
                 }
 
             } else {
                 callback(!enabled);
             }
 
         } catch (e) {
             callback(false);
             alert("run onFileUpload Eupload " + e.message)
             if(typeof this.props.getNotificationFunction === 'function'){
             this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
         }
        }
     }
 
     checkImageValidation = async (validateImage, response, assignResponseValue, fileId, callback) => {
 
         try {
            const { swaggerPostAPI ,swaggerGetAPI ,getValueUsingKey} = this.props;
             let { enabled = false, request = [], apiMethod = '', apiUrl = '', changeBindIn = '', changeResponseField = '' } = validateImage;
             if (enabled && apiUrl !== '') {
 
                 let { reqData = {}, savedObject = {} } = this.props;
                 let apiRequest = { data: {} };
                 Array.isArray(request) && request.map((item) => {
                     const { key = '', value = '', isFromResponse = false } = item;
                     if (key !== '' && key === 'fileUniqueId') {
                         apiRequest.data[key] = fileId;
                     } else if (key !== '' && key === 'userIdentifier') {
                         if (localStorage.getItem('user') !== null && localStorage.getItem('user') !== undefined)
                             apiRequest.data[key] = localStorage.getItem('user');
                         else if (sessionStorage.getItem('user') !== null && sessionStorage.getItem('user') !== undefined)
                             apiRequest.data[key] = sessionStorage.getItem('user');
                     } else if (key !== '' && typeof getValueUsingKey === 'function') {
                         if (isFromResponse) {
                             apiRequest.data[key] = getValueUsingKey(value, response);
                         } else {
                             apiRequest.data[key] = getValueUsingKey(value, { ...savedObject, ...reqData });
                         }
                     } else {
                         apiRequest.data[key] = '';
                     }
                 });
 
                 let resData = {};
                 if (apiMethod !== '' && apiMethod.toString().toLowerCase() === 'post' && typeof swaggerPostAPI === 'function') {
                     resData = await swaggerPostAPI(apiUrl, apiRequest, true);
                 } else if(typeof this.props.swaggerGetAPI === 'function'){
                     if (apiUrl.toString().indexOf("?")) {
                         apiUrl = apiUrl + '&' + encodeQueryData(apiRequest.data);
                     } else {
                         apiUrl = apiUrl + '?' + encodeQueryData(apiRequest.data);
                     }
                     resData = await swaggerGetAPI(apiUrl, apiRequest, true);
                 }
 
                 const { responseCode = 1, errCode = '' } = resData;
                 if (responseCode === 0) {
                     if (changeBindIn !== '' && changeResponseField !== '' && typeof getValueUsingKey === 'function') {
                         setTimeout(() => {
                             assignResponseValue(changeBindIn, getValueUsingKey(changeResponseField, resData));
                         }, 1000);
                     }
                     callback(true);
                 } else if(typeof this.props.getNotificationFunction === 'function'){
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.${errCode}` }));
                     callback(false);
                 }
 
             } else {
                 callback(!enabled);
             }
 
         } catch (e) {
             callback(false);
             alert("run onFileUpload Eupload " + e.message)
             if(typeof this.props.getNotificationFunction === 'function'){
             this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
         }
        }
     }
 
     handleOnChangeEvent = (e) => {
         let targetFile = e.target.files;
         const { getFileSizeToBase64String } = this.props
         const { optionsObj: { onChangeURL = '', isShowFileDetails = false, name: inputName = '', size, type: validFileType = [], isCompress: { enabled = false } = {}, isCompress = {} } = {}, assignResponseValue } = this.props;
         if (enabled && false) {
             console.log("in here")
             const { [0]: { type: originalFileType = '' } = [] } = e.target.files;
             if (originalFileType !== '' && Array.isArray(validFileType) && validFileType.length > 0 && !validFileType.includes(originalFileType)) {
                 this.props.onChange(e.target.type, e.target.name, e.target.value, '', targetFile)
             } else if(typeof getFileSizeToBase64String === 'function'){
                 const { optionsObj: { name: inputName = '' } = {} } = this.props;
                 var self = this;
                 this.convertToCompressFile(e, isCompress).then(function (compressResponse) {
                     const { [0]: { data: fileImage = '', alt: fileName = '', ext: fileType = '', prefix = '' } = [] } = compressResponse;
                     const sizeIn = 'kb';
                     const fileSize = getFileSizeToBase64String(fileImage, sizeIn) + sizeIn;
                     const fileExtension = '.' + fileName.toString().split('.').pop();
                     let fileData = {
                         imageUrl: prefix + fileImage,
                         name: fileName,
                         size: getFileSizeToBase64String(fileImage, sizeIn),
                         sizeLabel: fileSize,
                         type: fileType,
                         fileExtension: fileExtension
                     }
                     // self.setState({ fileData: fileData, _openWebCamera: false }, () => self.setValue('onFileUpload', JSON.stringify(fileData[inputName]), inputName));
                     // this.setValue('', fileData, inputName, true);
                     self.setValue('onFileUpload', JSON.stringify(fileData[inputName]), inputName)
                 });
             }
         } else {
             // console.log("run")
             let startProcess = this.checkFileValidation(targetFile[0], inputName, validFileType, size);
             const { [0]: { name: fileName = '', size: fileSize = '', type: fileType = '' } = {} } = targetFile;
             if (startProcess) {
                 assignResponseValue(inputName, 'loading');
                 this.onChangeCallAPI(e);
             }
         }
     }
 
     async onChangeCallAPI(e, webCameraObj = {}) {
 
         try {
             // console.log("onChangeCallAPI", e.target);
             const { optionsObj: { validateImage = {}, onChangeURL = '', type = '', name: inputName = '', id = '', kycPath = '', kycResponseBindFrom = '' } = {}, assignResponseValue, reqData, savedObject } = this.props;
             const { size: webCamSize = '', name: webCamName = '', type: webCamType = '', /* inputName = '', */ filePath = '' } = webCameraObj;
             // console.log('onChangeURL :', onChangeURL)
             if (onChangeURL !== '') {
                 const { defaultLng, optionsObj: { size, type, name = '', checkHeader: { enable: enabled = false, columns = [], rowCount = 0, rowCountErrorMessage: { locale: { [this.props.defaultLng]: errorRows = '' } = {} } = {}, columnRegex = [] } = {} } = {} } = this.props;
                 let targetFile = Object.keys(webCameraObj).length > 0 ? {} : e.target;
                 let dynamicKeyValue = 'frm_file_' + (name !== '' ? name : 'textFileInput');
                 let fieldId = name !== '' ? name : dynamicKeyValue + "id";
                 let startProcess = true;//;this.checkFileValidation(e, webCameraObj);
 
                 const formData = new FormData();
                 if (kycPath !== '') {
                     let kycPathNew = kycPath;
                     // console.log("kycResponseBindFrom", kycResponseBindFrom, savedObject)
                     if (kycResponseBindFrom !== '') {
                         kycPathNew = kycPathNew + dot.pick(kycResponseBindFrom, savedObject);//getValueUsingKey(kycResponseBindFrom, savedObject)
                     }
                     // console.log('kycPathNew :', kycPathNew, savedObject)
                     formData.append('keyType', kycPathNew);
                 } else {
                     formData.append('kycField', inputName);
                 }
                 // console.log('file data :', targetFile.files[0], webCameraObj)
                 formData.append(kycPath !== '' ? 'files' : 'file', Object.keys(webCameraObj).length > 0 ? webCameraObj : targetFile.files[0]);
 
                 if (startProcess) {
                     if (enabled) {
                         try {
                             let reader = new FileReader();
                             reader.onloadend = () => {
                                 const parseData = PapaParse.parse(reader.result, PapaParse.ParseConfig);
                                 let { data: { [0]: fileHeaders = [] } = {}, data } = parseData;
                                 if (Array.isArray(fileHeaders) && fileHeaders.length === columns.length) {
                                     let fieldCount = 0;
                                     columns.map((value, index) => {
                                         if (fileHeaders[index] !== undefined && value.toLowerCase() === fileHeaders[index].toLowerCase()) {
                                             fieldCount++;
                                         }
                                     });
 
                                     if (fieldCount === columns.length) {
                                         if (data.length > 1 && data.length <= parseFloat(rowCount)) {
 
                                             let emptyFields = false, skipValidation = false;
                                             data.map((value, mainIndex) => {
                                                 if (mainIndex === 0 || (mainIndex + 1 === data.length && data[mainIndex].length === 1)) {
                                                     return false;
                                                 }
                                                 columns.map((column, index) => {
                                                     const { [index]: { regex = '', message: { locale: { [defaultLng]: errorMessage = '' } = {} } = {} } = {} } = columnRegex;
                                                     if (value.length === columns.length && value[index] !== undefined && value[index].trim() !== '' && value[index].trim() !== null) {
                                                         if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage !== '') {
                                                             NotificationManager.error(errorMessage);
                                                             emptyFields = true;
                                                             skipValidation = true;
                                                         } else if (regex !== '' && !validator.matches(value[index], regex) && !skipValidation && errorMessage === '') {
                                                             skipValidation = true;
                                                         }
                                                     } else {
                                                         emptyFields = true;
                                                     }
                                                 })
                                             });
 
                                             if (emptyFields) {
                                                 $("#" + fieldId).val('');
                                                 this.props.onChange('file_type1', inputName, {})
                                                 if (!skipValidation)
                                                     NotificationManager.error(this.props.intl.formatMessage({ id: 'validationError.csvFieldEmpty' }));
                                             } else {
                                                 // let fileType = targetFiles[0].type;
                                                 this.uploadFile(formData, targetFile);
                                             }
 
                                         } else {
                                             $("#" + fieldId).val('');
                                             this.props.onChange('file_type1', inputName, {})
                                             NotificationManager.error(errorRows);
                                         }
                                     } else {
                                         $("#" + fieldId).val('');
                                         this.props.onChange('file_type1', inputName, {})
                                         NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.csvFileUploadError" }));
                                     }
                                 } else {
                                     $("#" + fieldId).val('');
                                     this.props.onChange('file_type1', inputName, {})
                                     NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.csvFileUploadError" }));
                                 }
 
                             }
                             reader.readAsText(targetFile.files[0]);
 
                         } catch (e) {
                             this.props.onChange('file_type1', inputName, {})
                             NotificationManager.error(this.props.intl.formatMessage({ id: "message.pleaseTryAfterSometime" }));
                         }
 
                     } else {
                         // console.log("before uploadFile", targetFile);
                         this.uploadFile(formData, Object.keys(webCameraObj).length > 0 ? webCameraObj : targetFile, inputName, targetFile.files, validateImage);
                     }
                 } else {
                     $("#" + fieldId).val('');
                     this.props.onChange('file_type1', inputName, {})
                     this.setState({ fileData: {} });
                     NotificationManager.error(this.props.intl.formatMessage({ id: "validationError.invalidFileType" }));
                 }
             }
         } catch (e) {
             alert("run onFileUpload E || " + e.message)
         }
     }
 
     render() {
         const { errorMsg, defaultLng, optionsObj = {}, reqData = {}, intl, defaultValue , FileDetails, ModelDialog} = this.props;
         let {
             id = 'file_upload_',
             key = '',
             className = '',
             label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
             name = '',
             type = '',
             required = false,
             isDisabled = false,
             multiple = false,
             onBlurURL = '',
             onFocusURL = '',
             onChangeURL = '',
             showLink = false,
             labelAlignment = 'top-left',
             icon = '',
             iconPosition = 'right',
             link: {
                 url: lnkUrl = '',
                 position: lnkPosition = 'right',
                 label: { locale: { [defaultLng]: lnkLabel = '' } = {} } = {}
             } = {},
             isMerge: {
                 enabled: isShowMerge = false,
                 icon: icon1 = '',
                 orTitle: { locale: { [defaultLng]: orLabel = '' } = {} } = {},
                 placeholder: { locale: { [defaultLng]: placeHolderLabel1 = '' } = {} } = {},
                 isEnabledWebCam: mergeWebCam = false
             } = {},
             helpText: { locale: { [defaultLng]: fNote = '' } = {} } = {},
             placeholder: { locale: { [defaultLng]: placeHolderLabel = '' } = {} } = {},
             isShowFileDetails = false,
             isEnabledWebCam = false,
             extraClass = '',
             ComponentType = '',
             webConfig: {
                 className: webCampClassName = 'mdl_card_photo',
                 idealResolution = { width: 700, height: 500 },
                 imageType = 'JPG',
                 isImageMirror = false,
                 isMaxResolution = false,
                 isSilentMode = false,
                 imageCompression = 1,
                 isDisplayStartCameraError = true,
                 isFullscreen = false,
                 sizeFactor = 1
             } = {}
         } = optionsObj;
 
         // console.log('webConfig :', idealResolution)
         // let { loader } = this.state;
         let { [name]: fingerData = '' } = reqData;
         const { imageUrl: fileImage = '', name: fileName = '', size: fileSize = '', type: fileType = '', fileExtension = '' } = fingerData;
 
         // alert(fileName + "|" + fileType + "|" + fileSize + "|fileImage:" + fileImage)
         // console.log('file render :', this.props, this.state)
         // console.log('file render fileData:', fileData, name, defaultValue)
 
         // placeHolderLabel = Object.keys(placeHolder).length > 0 ? placeHolderLabel : placeHolder;
         // placeHolderLabel1 = Object.keys(isMerge.placeHolder).length > 0 ? placeHolderLabel1 : isMerge.placeHolder;
         let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
         let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
         let utilityObj = {};
         if (!isDisabled) {
             utilityObj = {
                 download: { enabled: true, icon: 'moon-Cloud-Download', downloadFile: () => this.downloadFile(name) },
                 delete: { enabled: true, icon: 'moon-Delete', deleteFile: () => this.deleteFile() },
                 // icon : 'moon-info'
             }
         }
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                     {<div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                         {
                             ((fingerData !== 'loading') && isShowFileDetails && Object.keys(fingerData).length > 0 && !errorMsg)
                                 ?
                                 <FileDetails
                                     fileImage={fileType.indexOf('image') !== -1 ? fileImage : ''}
                                     fileTitle={fileName}
                                     fileSubTitle={fileSize}
                                     isShowUtility={true}
                                     utilityObj={utilityObj}
                                     extraClass={`${isDisabled ? 'disabled' : ''} ${extraClass}`}
                                     {...this.props}
                                 />
                                 :
                                 <Fragment>
                                     <div className="file_type1">
                                         {fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         {
                                             isShowMerge
                                                 ?
                                                 <div className="merge_area">
                                                     <div className="merge_brd">
                                                         <div className="or">{orLabel}</div>
                                                         <Label className="item" key={`mfu_key_${name !== '' ? name : dynamicKey}`} htmlFor={`mfu_${name !== '' ? name : dynamicKey}`}>
                                                             {placeHolderLabel}
                                                             {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                             <Input
                                                                 {...(multiple === true && { multiple })}
                                                                 type="file"
                                                                 className={className}
                                                                 key={`mfu_key_${name !== '' ? name : dynamicKey}`}
                                                                 id={`mfu_${name !== '' ? name : dynamicKey}`}
                                                                 name={name !== '' ? name : 'mk_fle_uld'}
                                                                 disabled={isDisabled ? isDisabled : false}
                                                                 required={required ? required : false}
                                                                 accept={(type !== "" && Array.isArray(type) && type.length > 0) ? type : '*.*'}
                                                                 onBlur={onBlurURL ? (e) => this.handleOnBlurEvent(e) : () => ({})}
                                                                 onFocus={onFocusURL ? (e) => this.handleOnFocusEvent(e) : () => ({})}
                                                                 onChange={isDisabled ? () => ({}) : ((e) => this.handleOnChangeEvent(e))}
                                                             />
                                                         </Label>
                                                         <Label className="item" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(ComponentType))}>
                                                             {placeHolderLabel1}
                                                             {icon1 !== '' && <span className="icon"><i className={icon1}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                         </Label>
                                                     </div>
                                                 </div>
                                                 :
                                                 <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`} onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(ComponentType))}>
                                                     {placeHolderLabel}
                                                     {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                                 </Label>
                                         }
                                     </div>
                                     {fNote && <div className="note_txt">{fNote}</div>}
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                     {/* <div className="file_type1" onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(ComponentType))}>
                                     {fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                     {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                                     <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`}>
                                         {placeHolderLabel}
                                         {icon !== '' && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                     </Label>
                                     {errorMsg && <div className="validation_error">{errorMsg}</div>}
                                 </div> */}
                                 </Fragment>
                         }
                     </div>}
                 </FormGroup>
             </Fragment >
         )
     }
 }
 
 
 export default FileUploadMobile;