/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Form control file type1
 *
 * Initial all package and component required for this component
 * injectIntl : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
 import axios, { post } from 'axios';
 import { Label, FormGroup } from 'reactstrap';
//  const { swaggerPostAPI, swaggerGetAPI, redirectToLogin, getValueUsingKey, callNativeFunction, convertBase64ToFile, getNotificationFunction, checkReactNativeWebView, base64StringCompress } = require('DefaultHelpers');
 // var LZString = require('lz-string');
//  import AppConfig from 'DefaultConstants/AppConfig';
 import $ from 'jquery';
 import dot from 'dot-object';
 dot.override = true;
 
 /**
  * Start File Type1 class component
  * @state {*Object} reqData
  */
 class FingerPrintMobile extends Component {
     constructor(props) {
         super(props);
         this.state = {
             fileData: {},
             // loader: props.optionsObj.type === '1' ? true : false,
             loader: true,
             name: props.optionsObj.name
         }
 
         this.setValueForFinger = this.setValueForFinger.bind(this);
         // if (props.optionsObj.name !== undefined && props.optionsObj.name !== '' && checkReactNativeWebView()) {
         // alert("run call")
         window.FingerPrint = this;
         let self = this;
         const { props: { optionsObj: { name: inputName = '' } = {} } = {} } = self;
 
         setTimeout(function () {
             $("#divForAddScript").append(`<script type="text/javascript">function onDataReceiveFromRN${inputName}(child_id, data){ window.FingerPrint.setValueForFinger(child_id, data);}</script>`)
         }, 500);
         // }
     }
 
     componentDidMount() {
         this.setState({ loader: false });
     }
 
     setValueForFinger(child_id, data) {
         // console.log('setValue :', child_id, data, fileFieldName, JSON.parse(data), isCompress)
         // alert('setValueForFinger :' + child_id)
         if (child_id === "onGetFingerPrint") {
             // alert('onGetFingerPrint :'+ JSON.stringify(data))
             try {
                const { convertBase64ToFile} = this.props;
                 let resData = data.replace(/__@@__/g, '"');//(data);
                 resData = JSON.parse(resData);
                 let { value = '', inputName = '' } = resData;
                 const inputConfiguration = this.props.getInputConfigurationBaseOnInputName(inputName);
                 const { isCompress: { enabled: isCompressEnabled = false, removeContentBit = false, isString = false } = {} } = inputConfiguration;
                 const { optionsObj: { onChangeURL = '', kycPath = '', responseBindFrom = '' } = {}, savedObject, assignResponseValue ,base64StringCompress} = this.props;
 
                 assignResponseValue(inputName, 'loading');
                 if (isCompressEnabled) {
                     // alert('ifffffffff')
                     if (removeContentBit && value.indexOf(',') > -1 && typeof base64StringCompress === 'function') {
                         // let newValue = skipDataReplace ? value.split(',') : value.split(';');
                         let newValue = value.split(',');
                         value = newValue[1];
                     }
                     value = base64StringCompress(value);
                     assignResponseValue(inputName, value);
                 } else if(typeof convertBase64ToFile === 'function'){
                     // alert('elseeeeeeeeeeee')
                     let fileData = [{
                         // imageUrl: value,
                         name: inputName,
                         // size: size,
                         // sizeLabel: sizeLabel,
                         // type: type,
                         // fileExtension: ''
                     }]
                     // this.props.onChange('fingerprint', inputName, fileData, '', fileData, '', '', 1)
                     // this.uploadFileFromNative(sentObject);
                     let formDataObject = convertBase64ToFile(value, inputName)
                     // console.log('formDataObject :', formDataObject)
                     let { formData, blob } = formDataObject;
                     if (kycPath !== '') {
                         let kycPathNew = kycPath;
                         if (responseBindFrom !== '') {
                             kycPathNew = kycPathNew + dot.pick(responseBindFrom, savedObject);//getValueUsingKey(responseBindFrom, savedObject)
                         }
                         formData.append('keyType', kycPathNew);
                     } else {
                         formData.append('kycField', inputName);
                     }
                     formData.append(kycPath !== '' ? 'files' : 'file', blob);
                     let targetFile = {
                         files: [{
                             name: inputName,
                             type: ''
                         }]
                     }
                     this.uploadFile(formData, targetFile, inputName);
                 }
             } catch (e) {
                 alert("run onGetFingerPrint E " + e.message)
                 if (typeof this.props.getNotificationFunction === 'function') {
                     this.props.getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
                 }
             }
         }
     }
 
     // function for file upload into server and get id from response and set into request Object
     uploadFile = async (formData, targetFile, inputFieldName = '') => {
        const { AppConfig: { nodeAPIUrl = {}, authorizationToken : AuthorizationToken = {} } = {} , swaggerGetAPI, redirectToLogin} = this.props;
         // this.setState({ loader: true });
         const { optionsObj: { onChangeURL = '', changeBindIn = '', changeResponseField = '', changeMethod = '', name: inputName = '' } = {}, assignResponseValue } = this.props;
 
         let response = '';
         const loaderTime = 200;
         const url = nodeAPIUrl + onChangeURL;
         let authorizationToken = localStorage.getItem('front_authorize_token');
         const selfProcessStart = sessionStorage.getItem('selfProcessStart') !== undefined ? sessionStorage.getItem('selfProcessStart') : '';
         if (selfProcessStart !== '' && selfProcessStart == 1) {
             authorizationToken = sessionStorage.getItem('front_temp_authorize_token');
         }
         const config = {
             headers: {
                 'content-type': 'multipart/form-data', // 'application/x-www-form-urlencoded'
                 'authorization': AuthorizationToken + authorizationToken
                 // get token from local storage
             }
         }
 
         if (changeMethod !== '' && changeMethod === 'POST') {
             var self = this;
             // alert("call api")
             // response = await swaggerPostAPI(onChangeURL, formData, 99); // pass 99 for add content type extra for file
             try {
                 post(url, formData, config).then((apiResponse) => {
                     const { data: response = {} } = apiResponse;
                     // alert("call api||" + JSON.stringify(apiResponse))
 
                     // response = { responseCode: 0, data: { fileUniqueId: "abc" + (Math.random()) } }
                     if (apiResponse !== undefined && apiResponse.status === 401 && typeof redirectToLogin === 'function') {
                         redirectToLogin();
                     } else if (response.responseCode === 0) {
                         let bindData = '';
                         if (changeResponseField !== '') {
                             bindData = dot.pick(changeResponseField, response);
                         } else {
                             bindData = dot.pick('data.fileUniqueId', response);
                         }
                         // console.log('bindData :', bindData)
 
                         const { files: { [0]: { name = '' } = {} } = {} } = targetFile;
                         /* if (name !== '') {
                             let extension = name.toString().split('.').pop();
                             bindData = bindData + '.' + extension;
                         } */
                         // alert("bindData|" + bindData + "|" + inputFieldName)
                         // this.setState({ fileData: bindData });
                         let { fileData } = self.state;
                         fileData[inputFieldName] = bindData;
                         self.setState({ fileData });
                         if (typeof assignResponseValue === 'function') {
                             if (changeBindIn !== '')
                                 assignResponseValue(changeBindIn, bindData, ''); // first argument field and second response value
                             else
                                 assignResponseValue(inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', bindData, '');
                             // self.props.onChange(targetFile.type, name !== '' ? name : 'textDatePickerInput', targetFile.value, '', targetFile.files, '', '', response.data.fileUniqueId)
                         }
                     } else if (response.responseCode > 0) {
                         // this.setState({ fileData: {} });
                         let { fileData } = self.state;
                         fileData[inputFieldName] = bindData;
                         self.setState({ fileData });
                         this.props.onChange('file_type1', inputName, {})
                         if (changeBindIn === '')
                             self.props.onChange(targetFile.type, inputFieldName !== '' ? inputFieldName : 'textDatePickerInput', '', '', '')
                         self.props.onError(inputName !== '' ? inputName : 'textDatePickerInput', `error.message.${response.errCode !== undefined ? response.errCode : 9999}`)
                         // getNotificationFunction('error', this.props.intl.formatMessage({ id: `error.message.{}` }));
                     }
                     setTimeout(() => {
                         this.setState({ loader: false, mdlOpen: false });
                     }, loaderTime);
                 })
             } catch (e) {
                 this.setState({ fileData: {} });
                 alert("run onFileUpload Eupload " + e.message)
                 // getNotificationFunction('error', this.props.intl.formatMessage({ id: "common.pleaseTryAfterSometime" }));
             }
             // to do handle response of post method
         } else if(typeof swaggerGetAPI === 'function'){ 
             response = await swaggerGetAPI(onChangeURL, data, true);
             // response = { responseCode: 0, data: { billAmount: 1000 } }
             if (response.responseCode === 0) {
                 if (typeof assignResponseValue === 'function') {
                     assignResponseValue(changeBindIn, response.data[changeResponseField]); // first argument field and second response value
                 }
             } else if (response.responseCode === 1) {
                 this.setState({ fileData: {} });
                 this.props.onError(e.target.name, `error.message.${response.errCode}`)
             }
             setTimeout(() => {
                 this.setState({ loader: false, mdlOpen: false });
             }, loaderTime);
         }
     }
 
     componentWillUnmount() {
         this.setState({ fileData: {} })
     }
 
     onClickEvent = (e) => {
         const { callNativeFunction } = this.props
         // e.preventDefault();
         const { optionsObj: { isShowFileDetails = false, size, type } = {} } = this.props;
         const { name: inputName = '' } = this.state;
         // alert('onClickEvent :'+ inputName)
         if (typeof callNativeFunction === 'function') {
             callNativeFunction("onGetFingerPrint", { "formatType": "BMPBase64", inputName });
         }
     }
 
     render() {
         const { errorMsg, defaultLng, optionsObj = {}, reqData = {}, intl, defaultValue ,checkReactNativeWebView} = this.props;
         let {
             id = 'finger_print_',
             className = '',
             label: { locale: { [defaultLng]: labelTitle = '' } = {} } = {},
             name = '',
             required = false,
             isDisabled = false,
             labelAlignment = 'top-left',
             icon = '',
             iconPosition = 'right',
             placeholder: { locale: { [defaultLng]: placeHolderLabel = '' } = {} } = {},
             helpText: { locale: { [defaultLng]: fNote = '' } = {} } = {},
             extraClass = '',
             componentType = typeof checkReactNativeWebView === 'function' && (checkReactNativeWebView() ? '' : '1'), //1 for web & blank for application.
             modalConfig: {
                 enabled: mdlEnabled = true,
                 label: { locale: { [defaultLng]: mdlLabelTitle = 'common.fingerPrint' } = {} } = {},
                 className: mdlClassName = 'mdl_450',
                 anyClickClose = false
             } = {}
         } = optionsObj;
 
         let { [name]: fingerData = '' } = reqData;
         let dynamicKey = 'frm_file_' + (name !== undefined ? name : 'textFileInput');
         let labelString = labelAlignment !== '' ? labelAlignment.toString().toLowerCase() : '';
         let classLabel = labelString === 'top-left' || labelString === 'top-right' ? 'col' : 'col';
         let classInput = labelString === 'top-left' || labelString === 'top-right' ? 'col-12' : 'col-md-9 col-sm-12';
         let lableAlign = labelString === 'right' || labelString === 'top-right' ? 'right' : 'left';
 
         console.log('render :', JSON.stringify(reqData))
 
 
         return (
             <Fragment>
                 <FormGroup className="row" key={dynamicKey}>
                     {
                         labelString === 'right'
                             ?
                             <Fragment>
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div className="file_type1" onClick={isDisabled ? (() => ({})) : ((e) => this.onClickEvent(e))}>
                                         {fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`}>
                                             {placeHolderLabel}
                                             {(fingerData === '' && icon !== '') && <span className="icon"><i className={icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                             {(fingerData !== '' && fingerData !== 'loading') && <span className="i_icon material-icons highlight_green">check_circle</span>}
                                         </Label>
                                     </div>
                                 </div>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                             </Fragment>
                             :
                             <Fragment>
                                 {labelTitle !== '' && <Label className={`control-label ${classLabel}`} align={lableAlign}>{labelTitle}{required && <span className="text-danger">*</span>}</Label>}
                                 <div className={`${classInput} ${className}${errorMsg ? ' is_err' : ''}`}>
                                     <div className="file_type1" onClick={isDisabled ? () => ({}) : ((e) => this.onClickEvent(e))}>
                                         {fingerData === 'loading' && <div className="fl_loader"><i className="fa fa-spinner fa-spin" />{intl.formatMessage({ id: 'constant.loading' })}</div>}
                                         <Label className="inner_area" key={`tp_key_${name !== '' ? name : dynamicKey}`} htmlFor={`tp_${name !== '' ? name : dynamicKey}`}>
                                             {placeHolderLabel}
                                             {icon !== '' && <span className="icon"><i className={fingerData !== '' ? 'moon-checked fa-lg' : icon}><span className="path1"></span><span className="path2"></span><span className="path3"></span><span className="path4"></span><span className="path5"></span><span className="path6"></span></i></span>}
                                             {/* {(fingerData !== '' && fingerData !== 'loading') && <span className="i_icon">check_circle</span>} */}
                                         </Label>
                                     </div>
                                 </div>
                             </Fragment>
                     }
                 </FormGroup>
             </Fragment >
         )
     }
 }
 
 
 export default FingerPrintMobile;