/**
 * Auther : MobifinElite Developer
 * Created : 05-11-2019
 * Inner Form component
 *
 * Initial all package and component required for this component
 * IntlMessages : used for display label langauge wise.
 */
 import React, { Component, Fragment } from 'react';
//  const FormDynamic = require('DefaultComponents/FormDynamic').default
 import dot from 'dot-object';
 dot.override = true;
 
 /**
  * Start Otp class component
  * @state {*Object} reqData
  */
 class InnerForm extends Component {
     render() {
         // console.log('InnerForm 11111111111111111 :', this.props)
         const { defaultLng, optionsObj = {}, savedObject = {}, reqData = {}, onClick = () => ({}), parentSubmit = () => ({}) ,FormDynamic} = this.props;
         let { page_field_configuration: pageFieldConfiguration = [], isMultiple: { enabled: isMultipleEnabled = false, noOfIteration = 0, responseListKey = '' } = {} } = optionsObj;
         let reviewMultiResponse = [];
         // console.log('Inner Form :', reqData)
         if (isMultipleEnabled && responseListKey !== '') {
             // console.log('Inner formmmmmmmmmmmmmmmmmmmmmmmmmmmm :', isMultipleEnabled, responseListKey, savedObject)
             reviewMultiResponse = dot.pick(responseListKey, savedObject);
             /* reviewMultiResponse = [
                 {
                     APPLICANT_NAME: 'Salim Deraiya',
                     PROFESSION: '18',
                     PROFESSIONLabel: 'Business',
                     GENDER: 'Male',
                     MOBILE_NUMBER: '9898989898',
                     EMAIL: 'demo@gmail.com',
                     DOB: '04-Oct-1984',
                     MOTHER_NAME: 'Mother Name',
                     FATHER_NAME: 'Father Name',
                     SPOUSE_NAME: 'Spouse Name',
                     PRESENT_ADDRESS: '102 Testing',
                     PERMANENT_ADDRESS: '102 Testing',
                     COMMUNICATION_ADDRESS: '102 Testing'
                 },
                 {
                     APPLICANT_NAME: 'Salim Deraiya',
                     PROFESSION: '18',
                     PROFESSIONLabel: 'Business',
                     GENDER: 'Male',
                     MOBILE_NUMBER: '9898989898',
                     EMAIL: 'demo@gmail.com',
                     DOB: '04-Oct-1984',
                     MOTHER_NAME: 'Mother Name',
                     FATHER_NAME: 'Father Name',
                     SPOUSE_NAME: 'Spouse Name',
                     PRESENT_ADDRESS: '102 Testing',
                     PERMANENT_ADDRESS: '102 Testing',
                     COMMUNICATION_ADDRESS: '102 Testing'
                 },
                 {
                     APPLICANT_NAME: 'Salim Deraiya',
                     PROFESSION: '18',
                     PROFESSIONLabel: 'Business',
                     GENDER: 'Male',
                     MOBILE_NUMBER: '9898989898',
                     EMAIL: 'demo@gmail.com',
                     DOB: '04-Oct-1984',
                     MOTHER_NAME: 'Mother Name',
                     FATHER_NAME: 'Father Name',
                     SPOUSE_NAME: 'Spouse Name',
                     PRESENT_ADDRESS: '102 Testing',
                     PERMANENT_ADDRESS: '102 Testing',
                     COMMUNICATION_ADDRESS: '102 Testing'
                 }
             ] */
             noOfIteration = (Array.isArray(reviewMultiResponse) && reviewMultiResponse.length > 0) ? reviewMultiResponse.length : noOfIteration;
         }
         // console.log('noOfIteration :', responseListKey, savedObject, noOfIteration, reviewMultiResponse)
         return (
             <Fragment>
                 {
                     isMultipleEnabled
                         ?
                         <Fragment>
                             {
                                 Array(noOfIteration).fill(1).map((el, i) => {
                                     const { [i]: rvSavedData = [] } = reviewMultiResponse;
                                     // console.log('rvSavedData :', rvSavedData)
                                     // const rvSavedData = reviewMultiResponse.length > 0 ? reviewMultiResponse[i] : [];
                                     return (
                                         <FormDynamic
                                             {...this.props}
                                             defaultLng={defaultLng}
                                             inputControlObject={pageFieldConfiguration}
                                             parentSubmit={parentSubmit}
                                             savedData={rvSavedData}
                                             // handleBack={this.handleBack}
                                             hideClass={true}
                                             onClickOpenModal={onClick}
                                             isMultiple={true}
                                             currentIteration={i + 1}
                                             currentEditIndex={i}
                                         // {...this.props}
                                         />
                                     )
                                 })
                             }
                         </Fragment>
                         :
                         <FormDynamic
                             inputControlObject={pageFieldConfiguration}
                             parentSubmit={parentSubmit}
                             savedData={savedObject}
                             // handleBack={this.handleBack}
                             hideClass={true}
                             onClickOpenModal={onClick}
                             isMultiple={false}
                             {...this.props}
                         />
 
                 }
             </Fragment>
         )
     }
 }
 
 export default InnerForm;